unit GridtreeDemomain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics, Controls, Forms,
  Dialogs, sGridTree, StdCtrls, KControls, KGrids, ExtCtrls;

type
  TForm1 = class(TForm)
    KGrid1: TKGrid;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Button1: TButton;
    ChkBoxAlsKind: TCheckBox;
    BtnNodeDelete: TButton;
    BtnExpanded: TButton;
    ChkBoxExpanded: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BtnNodeDeleteClick(Sender: TObject);
    procedure BtnExpandedClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    GTree1: TSGridTree;

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure TForm1.FormCreate(Sender: TObject);
//var aRes1, aRes1k1, aRes2, aRes2k1, aRes3, aRes4 :TNodeResult;
begin
  GTree1:= TSGridTree.Create(self);
   GTree1.Align:=alLeft;
   GTree1.Parent:=self;
   GTree1.Clear;

  Splitter1.Left:=GTree1.Width+100;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  GTree1.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var aId: Cardinal;
begin
  if (GTree1.Row<0)or(GTree1.Row>=GTree1.RowCount) then Exit;
  aId:=GTree1.NodeGetId(GTree1.Row);
  //ist immer mindestens 0: if aId<0 then exit;

  GTree1.NodeAdd(aId,'AddSel:'+GTree1.Cells[0,GTree1.Row]+' '+TimeToStr(now),ChkBoxAlsKind.Checked);

end;

procedure TForm1.BtnNodeDeleteClick(Sender: TObject);
var aId: Cardinal;
begin
  if (GTree1.Row<0)or(GTree1.Row>=GTree1.RowCount) then Exit;
  aId:=GTree1.NodeGetId(GTree1.Row);
  if aId<1 then exit;

  GTree1.NodeDelete(aId);
end;

procedure TForm1.BtnExpandedClick(Sender: TObject);
var aId: Cardinal;
begin
  if (GTree1.Row<0)or(GTree1.Row>=GTree1.RowCount) then Exit;
  aId:=GTree1.NodeGetId(GTree1.Row);
  if aId<1 then exit;
  GTree1.NodeExpand(aId, ChkBoxExpanded.Checked);
end;

end.
